import os
import csv

os.chdir('C:\Users\christoff.jorgensen\Documents\Master\Data fra nett\csvtest')

##Finds all items in the folder
def search_folder(directory=None):
    """Searches the folder and puts all items in a list"""
    """Uses current work directory if no input"""
    if directory is None:
        directory = os.getcwd()
    files = []
    for filenames in os.listdir(directory):
        files.append(filenames)
    return files


##Searches all items in a list for .gpx files
def search_files(files):
    """Searches a list for .tcx-files in a folder"""
    trackpoints = []
    for items in files:
        if items.find('trackpoints') >= 0:
            trackpoints.append(items)
    return trackpoints

##Creates a table with all trackpoints for all tcx-files
def full_table(files):
    allTP = []
    for item in files:
        name = str(item).split('_')[0].strip("['")
        with open(item, 'r') as f:
            allTP.append((name, f.read()))
    return allTP

    
def to_csv(table, filename):
    """Prints a table to .csv. Works well for further analysis in excel"""
    filename += '.csv'
    with open(filename, 'wb') as csvfile: 
        export = csv.writer(csvfile, dialect='excel-tab')
        export.writerows(table)

def table_to_text(table):
    """Prints a table to a text file. Requires a table"""
    with open('all_TPs.csv', 'a') as f:
        i = 0
        while i < len(table):
            f.write(str(table[i]) + '\n')
            i += 1


def magic():
    files = search_folder()
    trackpoints = search_files(files)
    allTP = full_table(trackpoints)
    table_to_text(allTP)
