import os
from csv import writer

os.chdir('C:\Users\christoff.jorgensen\Documents\Master\Data fra nett\klima')

def imp_file(filename):
    """Imports csv-file"""
    table = []
    with open(filename, 'r') as f:
        for line in f:
            table.append(line.strip('\n'))
    return table


def find_day(year, month, day, weather_table):
    """Matches date with weather table to get correct weather"""
    for index, value in enumerate(weather_table):
        split = str(value).strip('(').strip(')').split(',')
        year_w = int(split[0])
        month_w = int(split[1])
        day_w = int(split[2])
        if ((year_w == year) and (month_w == month) and (day_w == day)):
            return index

def csv(table, filename):
    """Prints a table to a selected filename as a csv."""
    print "Printing", filename
    with open(filename, 'w') as csvfile:
        export = writer(csvfile, dialect='excel-tab')
        export.writerows(table) 
        
def merge(case_date, oslo, trHeim, krSand):
    """merges correct weather and city for all the cases."""
    index = 0
    old_date = str('2000/1/1')
    table = []
    
    for line in case_date:
        split = str(line).strip('(').strip(')').split('-')
        year = int(split[0])
        month = int(split[1])
        day = int(split[2])
        
        new_date = '/'.join(split)
    
        if new_date.find(old_date) < 0:
            index = find_day(year, month, day, oslo)
            old_date = new_date
            
        rain_o = str(oslo[index]).split(',')[-1].strip(" '").strip(')').strip("'")
        rain_t = str(trHeim[index]).split(',')[-1].strip(" '").strip(')').strip("'")
        rain_k = str(krSand[index]).split(',')[-1].strip(" '").strip(')').strip("'")

        temp_o = str(oslo[index]).split(',')[-2].strip(" '").strip("'")
        temp_t = str(trHeim[index]).split(',')[-2].strip(" '").strip("'")
        temp_k = str(krSand[index]).split(',')[-2].strip(" '").strip("'")

        table.append((new_date, rain_o, temp_o, rain_t, temp_t, rain_k, temp_k))

        if len(table)%250000 == 0:
            print new_date
            print len(table)
            print index

    csv(table, 'caseDate_weather.csv')
        

def magic():
    case_date = imp_file('dates.csv')
    case_date[0] = 0
    case_date.pop(0)

    oslo = imp_file('OSLO.csv')
    trHeim = imp_file('TRONDHEIM.csv')
    krSand = imp_file('KRISTIANSAND.csv')

    merge(case_date, oslo, trHeim, krSand)
    
