from math import copysign as cs
from csv import writer

def imp_csv(filename):
    """Imports csv"""
    table = []
    with open(filename, 'r') as f:
        for line in f:
            table.append(line.strip('\n'))

    return table

def segment():
    """Create segments"""
    slope = imp_csv('slope3.txt')
    lengths = imp_csv('dist3.txt')

    if (len(slope)!=len(lengths)):
        print len(slope)
        print len(lengths)
        raw_input("abort!")
    
    seg_ID = 0
    segments = []
    
    for index, value in enumerate(slope):
        print value
        """filters out bad values for slope"""
        if value == ' ':
            if slope[index-1] == ' ':
                segments.append((seg_ID, '.', float(lengths[index])))
            else:
                seg_ID += 1
                segments.append((seg_ID, '.', float(lengths[index])))
            continue
        
        elif slope[index-1] == ' ':
            if value == ' ':
                segments.append((seg_ID, '.', float(lengths[index])))
            else:
                seg_ID += 1
                segments.append((seg_ID, float(value), float(lengths[index])))
            continue
            
        elif value == '0.0':
            if slope[index-1] == '0.0':
                segments.append((seg_ID, float(value), float(lengths[index])))
            else:
                seg_ID += 1
                segments.append((seg_ID, float(value), float(lengths[index])))
            continue
                
        elif (cs(1, float(slope[index-1])) == cs(1, float(slope[index]))) and (slope[index-1] != '0'):
            segments.append((seg_ID, float(value), float(lengths[index])))
            continue
        
        else:
            seg_ID += 1
            segments.append((seg_ID, float(value), float(lengths[index])))
            continue

        
    print "Number of segments: ", seg_ID
    print "Length of table: ", len(segments)

    slopes = []
    temp = []
    old_segID = 0
    
    for line in segments: ##segments[0] is a dummy!
        spl = str(line).split(',')
        slope = spl[1]
        if slope == " '.'":
            slope = '.'
        else:
            slope = float(spl[1])
            
        segID = int(spl[0].strip('('))
        length = float(spl[2].strip(')'))
        
        if segID == old_segID:
            temp.append((segID, slope, length))
            
        else:
            max_seg_slope, avr_seg_slope, seg_length = calc(temp)
            slopes.append((segID-1, max_seg_slope, avr_seg_slope, seg_length))
            old_segID += 1
            temp = []
            temp.append((segID, slope, length))
            
    max_seg_slope, avr_seg_slope, seg_length = calc(temp)
    slopes.append((segID, max_seg_slope, avr_seg_slope, seg_length))

    print "Number of slopes:", len(slopes)

    csv(slopes, "slopes2.csv")
    csv(segments, "segments2.csv")
    
    merge(slopes, segments)

def calc(table):
    """calculates max, avr and len values"""
    tot_slope = 0
    max_slope = 0
    tot_len = 0
    
    for line in table:
        spl = str(line).split(',')
        for x in spl[1]:
            if x.isdigit():
                slope = float(spl[1])
                tot_slope = tot_slope + slope
                if abs(slope) > abs(max_slope):
                    max_slope = slope
                break
        else:
            max_slope = '.'
            tot_slope = '.'
        
        length = float(spl[2].strip(')'))
        tot_len = tot_len + length   
            
    if tot_slope != '.':
        avr_slope = tot_slope/len(table)
    else:
        avr_slope = '.'
    
    return max_slope, avr_slope, tot_len    
        
        
        
def merge(slopes, segments):
    exp = []
    print "len segments: ", len(segments)
    
    for line in segments:
        seg = str(line).split(',')
        segID = seg[0].strip('(')
        

        slp = str(slopes[int(segID)]).split(',')
        
        if slp[1] != " '.'":
            max_slope = float(slp[1])
            avr_slope = float(slp[2])
        else:
            max_slope = '.'
            avr_slope = '.'
            
        length = float(slp[3].strip(')'))
        exp.append((int(segID), max_slope, avr_slope, length))

    print "len exp: ", len(exp)
    
    exp.pop(0)
    exp.pop(-1)


    csv(exp, "merged2.csv")

def csv(table, filename):
    print "Printing", filename
    with open(filename, 'w') as csvfile:
        export = writer(csvfile, dialect='excel-tab')
        export.writerows(table)
