from xml.etree.ElementTree import fromstring
#from time import strptime, strftime
#from optparse import OptionParser
import sys
import re
import datetime
import time
import os

os.chdir('C:\\Users\\christoff.jorgensen\\Documents\\Master\\Python\\Garmin\\tcx')

'''
Created on 13. aug. 2013

Et hack som bygger p kode skrevet av: jake hofman (gmail: jhofman)
@author: tlev
'''
"""Slightly modified by cJorgensen"""


def findtext(e, name, default=None):
    """
    findtext

    helper function to find sub-element of e with given name and
    return text value

    returns default=None if sub-element isn't found
    """
    try:
        return e.find(name).text
    except:
        return default


def parsetcx(xml):
    """
    parsetcx

    parses tcx data, returning a list of all Trackpoints where each
    point is a tuple of 

      (activity, lap, timestamp, seconds, lat, longitude, alt, dist, heart, cad)

    xml is a string of tcx data
    """

    # remove xml namespace (xmlns="...") to simplify finds
    # note: do this using ET._namespace_map instead?
    # see http://effbot.org/zone/element-namespaces.htm
    xml = re.sub('xmlns=".*?"','',xml)

    # parse xml
    tcx=fromstring(xml)
    
    #Her henter vi ut data om enheten som er brukt til loggingen    
    enhets_type = tcx.findtext('.//Activity/Creator/Name')
    enhets_id = tcx.findtext('.//Activity/Creator/UnitId')
    enhets_product_id = tcx.findtext('.//Activity/Creator/ProductID')
    
    
    laps_tabell = []
    lapnum = 1
    for lap in tcx.findall('.//Lap'):
        calories = lap.findtext('Calories')
        time_total_seconds = lap.findtext('TotalTimeSeconds')
        distance_meters = lap.findtext('DistanceMeters')
        max_speed = lap.findtext('MaximumSpeed')
        laps_tabell.append((lapnum,
                            calories,
                            time_total_seconds,
                            distance_meters,
                            max_speed))
        lapnum = lapnum + 1
    
    activity = tcx.find('.//Activity').attrib['Sport']

    lapnum=0
    points=[]
    previous_dist=0
    for lap in tcx.findall('.//Lap'):
        # Setter lapnummer
        lapnum = lapnum + 1
        #print lapnum
        #print len(lap)
        
        for point in lap.findall('.//Trackpoint'):

            # time, both as string and in seconds GMT
            # note: adjust for timezone?
            timestamp = findtext(point, 'Time')
            if timestamp:
                tid = datetime.datetime.strptime(timestamp,'%Y-%m-%dT%H:%M:%S.%fZ')
                seconds = time.mktime(tid.timetuple())
            else:
                seconds = None

            # cummulative distance
            dist = findtext(point, 'DistanceMeters')
            #print dist
            if dist:
                lenke_distanse = float(dist) - float(previous_dist)
                previous_dist = dist
            else:
                lenke_distanse = 0
                
            # latitude and longitude
            position = point.find('Position')
            lat = findtext(position, 'LatitudeDegrees')
            longitude = findtext(position, 'LongitudeDegrees')

            # altitude
            alt = float(findtext(point, 'AltitudeMeters',0))
            
            # heart rate
            heart = int(findtext(point.find('HeartRateBpm'),'Value',0))

            # cadence
            cad = int(findtext(point, 'Cadence',0))
            # speed 
            #speed = float(findtext(point, 'Speed',0))
            speed = float(findtext(point, 'Extensions/TPX/Speed',0))
            #print "speed %0.2f" %speed 
            
            # append to list of points
            points.append((activity,
                           lapnum,
                           tid, 
                           seconds, 
                           lat,
                           longitude,
                           alt,
                           dist,
                           lenke_distanse,
                           speed,
                           heart,
                           cad))


    return laps_tabell, points, enhets_type, enhets_id, enhets_product_id




def magic():
    with open('295720613.tcx', 'r') as f:
        tcx = f.read()
    laps, points, enhets_type, enhets_id, enhets_product_id = parsetcx(tcx)
    print points

